Loading...
Searching...
No Matches
Content-MD5 Header
MIME Headers

The Content-MD5 header is an MD5 digest of the entity-body for the purpose of providing an end-to-end message integrity check (MIC) of the message-body. More...

## Macros

#define | MSG_CONTENT_MD5_INIT()
| Initializer for an msg_content_md5_t structure.

## Typedefs

typedef msg_generic_t | msg_content_md5_t
| The structure msg_content_md5_t contains representation of an Content-MD5 header.

## Enumerations

enum | { msg_content_md5_hash }

## Functions

msg_content_md5_t * | msg_content_md5_init (msg_content_md5_t x[1])
| Initialize an msg_content_md5_t structure.
int | msg_is_content_md5 (msg_header_t const *header)
| Test if header object is an instance of msg_content_md5_t.
msg_content_md5_t * | msg_content_md5_dup (su_home_t *home, msg_content_md5_t const *header)
| Duplicate (deep copy) msg_content_md5_t.
msg_content_md5_t * | msg_content_md5_copy (su_home_t *home, msg_content_md5_t const *header)
| Copy an msg_content_md5_t header structure.
msg_content_md5_t * | msg_content_md5_make (su_home_t *home, char const *s)
| Make a header structure msg_content_md5_t.
msg_content_md5_t * | msg_content_md5_format (su_home_t *home, char const *fmt,...)))
| Make a Content-MD5 header from formatting result.

## Variables

msg_parse_f | msg_content_md5_d
| Parse a Content-MD5 header.
msg_print_f | msg_content_md5_e
| Print a Content-MD5 header.
msg_hclass_t | msg_content_md5_class []
| Header class for Content-MD5 header.

## Detailed Description

The Content-MD5 header is an MD5 digest of the entity-body for the purpose of providing an end-to-end message integrity check (MIC) of the message-body.

Its syntax is defined in [RFC 1864, H14.15] as follows:

Content-MD5 = "Content-MD5" ":" md5-digest
md5-digest = <base64 of 128 bit MD5 digest as per @RFC1864>

## Macro Definition Documentation

## MSG_CONTENT_MD5_INIT

#define MSG_CONTENT_MD5_INIT | ( |  | ) |

Initializer for an msg_content_md5_t structure.

A static msg_content_md5_t structure must be initialized with the MSG_CONTENT_MD5_INIT() macro. For instance,

msg_content_md5_t msg_content_md5 = MSG_CONTENT_MD5_INIT;
msg_content_md5_t
msg_generic_t msg_content_md5_t
The structure msg_content_md5_t contains representation of an Content-MD5 header.
Definition msg_mime.h:67
MSG_CONTENT_MD5_INIT
#define MSG_CONTENT_MD5_INIT()
Initializer for an msg_content_md5_t structure.
Definition msg_mime_protos.h:3102

## Typedef Documentation

## msg_content_md5_t

typedef msg_generic_t msg_content_md5_t

The structure msg_content_md5_t contains representation of an Content-MD5 header.

The msg_content_md5_t is defined as follows:

typedef struct msg_generic_s
{
msg_common_t g_common[1]; // Common fragment info
msg_generic_t *g_next; // Link to next header
char const *g_string; // Header value
} msg_content_md5_t;
msg_common_t
struct msg_common_s msg_common_t
Common part of header.
Definition msg_types.h:89
msg_generic_s
Generic header.
Definition msg_types.h:151
msg_generic_s::g_common
msg_common_t g_common[1]
Common fragment info.
Definition msg_types.h:152
msg_generic_s::g_string
char const * g_string
Header value.
Definition msg_types.h:154
msg_generic_s::g_next
msg_generic_t * g_next
Link to next header.
Definition msg_types.h:153

## Enumeration Type Documentation

## anonymous enum

anonymous enum

Enumerator
msg_content_md5_hash | Hash of Content-MD5 header.

## Function Documentation

## msg_content_md5_copy()

msg_content_md5_t * msg_content_md5_copy | ( | su_home_t * | home,
|  | msg_content_md5_t const * | header )

inline

Copy an msg_content_md5_t header structure.

The function msg_content_md5_copy() copies a header structure header. If the header structure header contains a reference (`header->h_next`) to a list of headers, all the headers in that list are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header structure header.

Parameters

  home | memory home used to allocate new structure
  header | pointer to the header structure to be duplicated

When copying, only the header structure and parameter lists attached to it are duplicated. The new header structure retains all the references to the strings within the old header, including the encoding of the old header, if present.

Example
  content_md5 = msg_content_md5_copy(home, msg->msg_content_md5);
  msg_content_md5_copy
  msg_content_md5_t * msg_content_md5_copy(su_home_t *home, msg_content_md5_t const *header)
  Copy an msg_content_md5_t header structure.
  Definition msg_mime_protos.h:3231

Returns
  The function msg_content_md5_copy() returns a pointer to newly copied header structure, or NULL upon an error.

## msg_content_md5_dup()

msg_content_md5_t * msg_content_md5_dup | ( | su_home_t * | home,
|  | msg_content_md5_t const * | header )

inline

Duplicate (deep copy) msg_content_md5_t.

The function msg_content_md5_dup() duplicates a header structure header. If the header structure header contains a reference (`header->x_next`) to a list of headers, all the headers in the list are duplicated, too.

Parameters

  home | memory home used to allocate new structure
  header | header structure to be duplicated

When duplicating, all parameter lists and non-constant strings attached to the header are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header.

Example
  content_md5 = msg_content_md5_dup(home, msg->msg_content_md5);
  msg_content_md5_dup
  msg_content_md5_t * msg_content_md5_dup(su_home_t *home, msg_content_md5_t const *header)
  Duplicate (deep copy) msg_content_md5_t.
  Definition msg_mime_protos.h:3186

Returns
  The function msg_content_md5_dup() returns a pointer to the newly duplicated msg_content_md5_t header structure, or NULL upon an error.

## msg_content_md5_format()

msg_content_md5_t * msg_content_md5_format | ( | su_home_t * | home,
|  | char const * | fmt,
|  |  | ... )

inline

Make a Content-MD5 header from formatting result.

The function msg_content_md5_format() makes a new Content-MD5 header object using snprintf-formatted result as its value. The function first prints the arguments according to the format fmt specified. Then it allocates a new header structure, and uses the formatting result as the header value.

Parameters

  home | memory home used to allocate new header structure.
  fmt | string used as a printf()-style format
  ... | argument list for format

Note
  This function may be implemented as a macro calling msg_header_format().

Returns
  The function msg_content_md5_format() returns a pointer to newly makes header structure, or NULL upon an error.

## msg_content_md5_init()

msg_content_md5_t * msg_content_md5_init | ( | msg_content_md5_t | x[1] | ) |

inline

Initialize an msg_content_md5_t structure.

An msg_content_md5_t structure can be initialized with the msg_content_md5_init() function/macro. For instance,

msg_content_md5_t msg_content_md5;
msg_content_md5_init(&msg_content_md5);
msg_content_md5_init
msg_content_md5_t * msg_content_md5_init(msg_content_md5_t x[1])
Initialize an msg_content_md5_t structure.
Definition msg_mime_protos.h:3119

Parameters

  x | pointer to msg_content_md5_t structure

## msg_content_md5_make()

msg_content_md5_t * msg_content_md5_make | ( | su_home_t * | home,
|  | char const * | s )

inline

Make a header structure msg_content_md5_t.

The function msg_content_md5_make() makes a new msg_content_md5_t header structure. It allocates a new header structure, and decodes the string s as the value of the structure.

Parameters

  home | memory home used to allocate new header structure.
  s | string to be decoded as value of the new header structure

Note
  This function may be implemented as a macro calling msg_header_make().

Returns
  The function msg_content_md5_make() returns a pointer to newly maked msg_content_md5_t header structure, or NULL upon an error.

## msg_is_content_md5()

int msg_is_content_md5 | ( | msg_header_t const * | header | ) |

inline

Test if header object is an instance of msg_content_md5_t.

The function msg_is_content_md5() returns true (nonzero) if the header class is an instance of Content-MD5 header object and false (zero) otherwise.

Parameters

  header | pointer to the header structure to be tested

Returns
  The function msg_is_content_md5() returns true (nonzero) if the header object is an instance of header Content-MD5 header and false (zero) otherwise.

## Variable Documentation

## msg_content_md5_class

msg_hclass_t msg_content_md5_class[]

extern

Header class for Content-MD5 header.

The header class msg_content_md5_class defines how a Content-MD5 header header is parsed and printed. It also contains methods used by message parser and other functions to manipulate the msg_content_md5_t header structure.

Sofia-SIP 1.12.11devel - Copyright (C) 2006 Nokia Corporation. All rights reserved. Licensed under the terms of the GNU Lesser General Public License.